=== debian/changelog ===
snapcast (0.27.0+dfsg-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 23 Jul 2023 17:19:41 +0200

snapcast (0.27.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Add dependencies of meta plugins to Suggests.
  * Fix FTBFS with GCC 13. (Closes: #1037860)
    - Cherry-pick upstream fix as fix_ftbfs_gcc13.patch

 -- Felix Geyer <fgeyer@debian.org>  Thu, 15 Jun 2023 21:35:36 +0200
