## snapcast 0.28.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
-cmake_minimum_required(VERSION 3.2)
+cmake_minimum_required(VERSION 3.5)
 
 project(
   snapcast
   LANGUAGES CXX
-  VERSION 0.27.0)
+  VERSION 0.28.0)
 
 set(PROJECT_DESCRIPTION "Multiroom client-server audio player")
 set(PROJECT_URL "https://github.com/badaix/snapcast")
@@ -80,6 +80,8 @@
 endif()
 
 include(GNUInstallDirs)
+include(${CMAKE_SOURCE_DIR}/cmake/cppcheck.cmake)
+include(${CMAKE_SOURCE_DIR}/cmake/reformat.cmake)
 
 if(NOT WIN32)
   option(BUILD_SERVER "Build Snapserver" ON) # no Windows server for now
@@ -382,28 +384,3 @@
 if(BUILD_TESTS)
   add_subdirectory(test)
 endif(BUILD_TESTS)
-
-find_program(CLANG_FORMAT "clang-format")
-if(CLANG_FORMAT)
-  file(GLOB_RECURSE CHECK_CXX_SOURCE_FILES common/*.[ch]pp client/*.[ch]pp
-       server/*.[ch]pp)
-
-  list(REMOVE_ITEM CHECK_CXX_SOURCE_FILES "${CMAKE_SOURCE_DIR}/common/json.hpp")
-
-  add_custom_target(
-    reformat-source
-    COMMAND ${CLANG_FORMAT} -i -style=file ${CHECK_CXX_SOURCE_FILES}
-    COMMENT "Auto formatting of all source files")
-endif()
-
-find_program(CMAKE_FORMAT "cmake-format")
-if(CMAKE_FORMAT)
-  file(GLOB_RECURSE CHECK_CMAKE_SOURCE_FILES CMakeLists.txt)
-
-  add_custom_target(
-    reformat-cmake
-    COMMAND ${CMAKE_FORMAT} -i ${CHECK_CMAKE_SOURCE_FILES}
-    COMMENT "Auto formatting of all CMakeLists.txt files")
-endif()
-
-add_custom_target(reformat DEPENDS reformat-source reformat-cmake)
