=== client/CMakeLists.txt ===
--- 
+++ 
@@ -76,13 +76,6 @@
   list(APPEND CLIENT_LIBRARIES OpenSLES)
 
 else()
-  # if OGG then tremor or vorbis
-  if(OGG_FOUND)
-    list(APPEND CLIENT_SOURCES decoder/ogg_decoder.cpp)
-    list(APPEND CLIENT_LIBRARIES ${OGG_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${OGG_INCLUDE_DIRS})
-  endif(OGG_FOUND)
-
   # Tremor (fixed-point) or libvorbis (floating-point)
   if(TREMOR_FOUND)
     list(APPEND CLIENT_LIBRARIES ${TREMOR_LIBRARIES})
@@ -91,6 +84,13 @@
     list(APPEND CLIENT_LIBRARIES ${VORBIS_LIBRARIES})
     list(APPEND CLIENT_INCLUDE ${VORBIS_INCLUDE_DIRS})
   endif(TREMOR_FOUND)
+
+  # if OGG then tremor or vorbis
+  if(OGG_FOUND)
+    list(APPEND CLIENT_SOURCES decoder/ogg_decoder.cpp)
+    list(APPEND CLIENT_LIBRARIES ${OGG_LIBRARIES})
+    list(APPEND CLIENT_INCLUDE ${OGG_INCLUDE_DIRS})
+  endif(OGG_FOUND)
 
   if(FLAC_FOUND)
     list(APPEND CLIENT_SOURCES decoder/flac_decoder.cpp)
