=== debian/changelog ===
snapcast (0.28.0-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 23 Jun 2024 19:22:33 +0200

snapcast (0.28.0-1) unstable; urgency=medium

  * New upstream release.
    - Drop fix_ftbfs_gcc13.patch, applied upstream.
  * Fix FTBFS after successful build. (Closes: #1049247)
  * Update watch file to only consider stable versions.
  * Stop repacking the upstream tarball. snapweb has been split into
    an own project.
    - Drop disable_snapweb.patch

 -- Felix Geyer <fgeyer@debian.org>  Mon, 17 Jun 2024 21:47:56 +0200
