## snapcast 0.30.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,14 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.14)
+
+# find_package() uses uppercase <PackageName>_ROOT variables.
+if(POLICY CMP0144)
+  cmake_policy(SET CMP0144 NEW)
+endif()
 
 project(
   snapcast
   LANGUAGES CXX
-  VERSION 0.28.0)
+  VERSION 0.30.0)
 
 set(PROJECT_DESCRIPTION "Multiroom client-server audio player")
 set(PROJECT_URL "https://github.com/badaix/snapcast")
@@ -64,12 +69,12 @@
   endif()
 
   if(ASAN)
-    add_compile_options(-fsanitize=address)
+    add_compile_options(-fsanitize=address -Wno-error=maybe-uninitialized)
     add_link_options(-fsanitize=address)
   endif()
 
   if(TSAN)
-    add_compile_options(-fsanitize=thread)
+    add_compile_options(-fsanitize=thread -Wno-error=tsan)
     add_link_options(-fsanitize=thread)
   endif()
 
@@ -96,6 +101,7 @@
 option(BUILD_WITH_AVAHI "Build with AVAHI support" ON)
 option(BUILD_WITH_EXPAT "Build with EXPAT support" ON)
 option(BUILD_WITH_PULSE "Build with PulseAudio support" ON)
+option(BUILD_WITH_JACK "Build with JACK support" ON)
 
 if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
   message(
@@ -171,6 +177,8 @@
 
 find_package(Threads REQUIRED)
 
+find_package(OpenSSL REQUIRED)
+
 include(CMakePushCheckState)
 include(CheckIncludeFileCXX)
 include_directories(${INCLUDE_DIRS})
@@ -199,6 +207,13 @@
     if(ALSA_FOUND)
       add_compile_definitions(HAS_ALSA)
     endif(ALSA_FOUND)
+
+    if(BUILD_WITH_JACK)
+      pkg_search_module(JACK jack)
+      if(JACK_FOUND)
+        add_compile_definitions(HAS_JACK)
+      endif(JACK_FOUND)
+    endif(BUILD_WITH_JACK)
 
     if(BUILD_WITH_PULSE)
       pkg_search_module(PULSE libpulse)
@@ -355,7 +370,7 @@
     WINDOWS
     WIN32_LEAN_AND_MEAN
     UNICODE
-    _UNICODE
+    # _UNICODE
     _CRT_SECURE_NO_WARNINGS)
   add_compile_definitions(
     HAS_OGG
