=== client/CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,9 @@
 
 set(CLIENT_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} ${ATOMIC_LIBRARY} common)
 
-set(CLIENT_INCLUDE ${Boost_INCLUDE_DIR} ${CMAKE_SOURCE_DIR}/client
-                   ${CMAKE_SOURCE_DIR})
+include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/client)
+
+include_directories(SYSTEM ${Boost_INCLUDE_DIR})
 
 if(MACOSX)
   # Bonjour
@@ -44,20 +45,20 @@
   if(AVAHI_FOUND)
     list(APPEND CLIENT_SOURCES browseZeroConf/browse_avahi.cpp)
     list(APPEND CLIENT_LIBRARIES ${AVAHI_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${AVAHI_INCLUDE_DIRS})
+    include_directories(${AVAHI_INCLUDE_DIRS})
   endif(AVAHI_FOUND)
 
   # ALSA
   if(ALSA_FOUND)
     list(APPEND CLIENT_SOURCES player/alsa_player.cpp)
     list(APPEND CLIENT_LIBRARIES ${ALSA_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${ALSA_INCLUDE_DIRS})
+    include_directories(${ALSA_INCLUDE_DIRS})
   endif(ALSA_FOUND)
 
   if(PULSE_FOUND)
     list(APPEND CLIENT_SOURCES player/pulse_player.cpp)
     list(APPEND CLIENT_LIBRARIES ${PULSE_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${PULSE_INCLUDE_DIRS})
+    include_directories(${PULSE_INCLUDE_DIRS})
   endif(PULSE_FOUND)
 endif(MACOSX)
 
@@ -79,33 +80,42 @@
   # Tremor (fixed-point) or libvorbis (floating-point)
   if(TREMOR_FOUND)
     list(APPEND CLIENT_LIBRARIES ${TREMOR_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${TREMOR_INCLUDE_DIRS})
+    include_directories(${TREMOR_INCLUDE_DIRS})
   elseif(VORBIS_FOUND)
     list(APPEND CLIENT_LIBRARIES ${VORBIS_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${VORBIS_INCLUDE_DIRS})
+    include_directories(${VORBIS_INCLUDE_DIRS})
+    link_directories(${VORBIS_LIBRARY_DIRS})
   endif(TREMOR_FOUND)
 
   # if OGG then tremor or vorbis
   if(OGG_FOUND)
     list(APPEND CLIENT_SOURCES decoder/ogg_decoder.cpp)
     list(APPEND CLIENT_LIBRARIES ${OGG_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${OGG_INCLUDE_DIRS})
+    include_directories(${OGG_INCLUDE_DIRS})
+    link_directories(${OGG_LIBRARY_DIRS})
   endif(OGG_FOUND)
 
   if(FLAC_FOUND)
     list(APPEND CLIENT_SOURCES decoder/flac_decoder.cpp)
     list(APPEND CLIENT_LIBRARIES ${FLAC_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${FLAC_INCLUDE_DIRS})
+    include_directories(${FLAC_INCLUDE_DIRS})
+    link_directories(${FLAC_LIBRARY_DIRS})
   endif(FLAC_FOUND)
 
   if(OPUS_FOUND)
     list(APPEND CLIENT_SOURCES decoder/opus_decoder.cpp)
     list(APPEND CLIENT_LIBRARIES ${OPUS_LIBRARIES})
-    list(APPEND CLIENT_INCLUDE ${OPUS_INCLUDE_DIRS})
+    include_directories(${OPUS_INCLUDE_DIRS})
+    link_directories(${OPUS_LIBRARY_DIRS})
   endif(OPUS_FOUND)
+
+  if(SOXR_FOUND)
+    list(APPEND CLIENT_LIBRARIES ${SOXR_LIBRARIES})
+    include_directories(${SOXR_INCLUDE_DIRS})
+    link_directories(${SOXR_LIBRARY_DIRS})
+  endif(SOXR_FOUND)
 endif()
 
-include_directories(${CLIENT_INCLUDE})
 if(ANDROID)
   add_executable(libsnapclient.so ${CLIENT_SOURCES})
   target_link_libraries(libsnapclient.so ${CLIENT_LIBRARIES} log OpenSLES)
