=== debian/changelog ===
snapcast (0.30.0-1build1) plucky; urgency=medium

  * No-change rebuild for flac.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 14 Mar 2025 22:39:27 -0500

snapcast (0.30.0-1) unstable; urgency=medium

  * New upstream release.
    - Fixes CVE-2023-36177
  * Build-depend on libssl-dev.
  * Enable unit tests.
    - Build-depend on libcatch2-dev.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 18 Jan 2025 00:11:57 +0100
