=== debian/control ===
--- 
+++ 
@@ -12,6 +12,8 @@
                libexpat1-dev,
                libsoxr-dev,
                libpulse-dev,
+               libssl-dev,
+               libcatch2-dev,
                cmake
 Standards-Version: 4.1.4
 Homepage: https://github.com/badaix/snapcast
